/*
Motor de ajedrez xboard/winboard DanaSah
Pedro Castro

Funciones que envan informacin al GUI
*/

/* muestra informacin sobre el movimiento seleccionado, profundidad, puntuacin, tiempo
empleado y nodos examinados, compatible con Arena y otros GUI */
void print_pv(int depth, int score) 
{
	movimiento	mi;
	int i, j;
	char c;

	i = pv_longuitud[ply];	//calculamos la longuitud de la lnea

	if (i > 0) {
		//enviamos profundidad, puntos, tiempo, nodos
		printf("%d %d %d %d", depth, puntos, (get_ms()-tiempo_inicio)/10, nodos);

		//imprimimos la mejor linea
		for (j = 0; j < i; ++j) {
			mi = pv[0][j];
			if (pv[0][j].a == 0 && pv[0][j].de == 0)
				break;
			//letra a imprimir si hay una promocin
			switch (mi.tipo) {
				case PROMOCION_A_DAMA:
					c = 'q';
					break;
				case PROMOCION_A_TORRE:
					c = 'r';
					break;
				case PROMOCION_A_ALFIL:
					c = 'b';
					break;
				case PROMOCION_A_CABALLO:
					c = 'n';
					break;
				default:
					c = ' ';
			}
			printf(" %c%d%c%d%c", 
				'a' + COLUMNA(mi.de),
				8 - FILA(mi.de),
				'a' + COLUMNA(mi.a),
				8 - FILA(mi.a),
				c);
		}
		printf("\n");		//cuando terminamos con la linea debemos mandar un retorno de carro
		fflush(stdout);		//obligado por el protocolo xboard
	}
}

// indica al GUI el movimiento que debe realizar
void Enviar_Movimiento(movimiento m)
{
	char c;
	/* ahora indicamos al motor que tipo de movimiento tiene que hacer */
	switch (m.tipo) {
		case PROMOCION_A_DAMA:
			c = 'q';
			break;
		case PROMOCION_A_TORRE:
			c = 'r';
			break;
        case PROMOCION_A_ALFIL:
			c = 'b';
			break;
        case PROMOCION_A_CABALLO:
			c = 'n';
			break;
		default:
			c = ' ';
	}
	
	/*al enviar el movimiento al gui debemos anteponer la palabra move*/
	printf("move %c%d%c%d%c\n",
			'a' + COLUMNA(m.de), 
			8 - FILA(m.de),
			'a' + COLUMNA(m.a),
			8 - FILA(m.a),
			c);
}

/* si es final de partida indica el resultado de la misma y para el motor */
void imprime_resultado(int cuenta, movimiento *lista)
{
	int i;

	/* comprobamos si hay un movimiento legal */
	for (i = 0; i < cuenta; ++i)
		if (Hacer_Movimiento(lista[i])) {
			Deshacer();
			break;
		}
	if (i == cuenta) { // si hemos llegado al final de cuenta no hay movimientos entonces
		if (EstaEnJaque(turno)) {
			if (turno == BLANCO){
				//si toca mover a blancas y estn en jaque han perdido
				printf("0-1 {Black mates}\n");
				salir = VERDADERO;
			}
			else {
				//si toca mover a negras y estn en jaque han perdido
				printf("1-0 {White mates}\n");
				salir = VERDADERO;
			}
		}
		else {
			//tablas porque quien mueve est ahogado
			printf("1/2-1/2 {Stalemate}\n");
			salir = VERDADERO;
		}
	}
	else if (repeticion() == 2) {
		//tablas por repeticin de 3 veces la misma posicin
		printf("1/2-1/2 {Draw by repetition}\n");
		salir = VERDADERO;
	}
	else if (regla50 >= 100) {
		//tablas por la regla de los 50 movimientos
		printf("1/2-1/2 {Draw by 50 move rule}\n");
		salir = VERDADERO;
	}
	else if (tablas() == VERDADERO) {
		//tablas por que no hay suficiente material para hacer mate
		printf("1/2-1/2 {Draw by insufficient material}\n");
		salir = VERDADERO;
	}
}
