/*
Motor de ajedrez xboard/winboard DanaSah
Pedro Castro

Funciones para evaluar una posicin.
*/

/*bonus y malus*/

#define PEON_BLOQUEADO			   -20
#define PEON_PASADO_NOAISLADO		20

#define	ALFIL_ATRAPADO			  -160

#define	CABALLO_ATRAPADO		  -120

#define	TORRE_COLUMNASEMIABIERTA	10
#define	TORRE_COLUMNAABIERTA		15
#define	TORRE_EN_SEPTIMA			20
#define TORRE_ATRAPADA			   -70

#define	DAMA_PREMATURA			   -10
#define DAMA_EN_SEPTIMA				10

#define DESARROLLO_LENTO			-5

#define REY_ENROCADO				30

// tabla para evaluar posiciones segn el lugar de las piezas
int peon_blanco[64] = {
	  0,   0,   0,   0,   0,   0,   0,   0,
	  5,  10,  15,  20,  20,  15,  10,   5,
	  4,   8,  12,  16,  16,  12,   8,   4,
	  3,   6,   9,  12,  12,   9,   6,   3,
	  2,   4,   6,   8,   8,   6,   4,   2,
	  1,   2,   3,   4,   4,   3,   2,   1,
	  0,   0,   0,  -5,  -5,   0,   0,   0,
	  0,   0,   0,   0,   0,   0,   0,   0
};

int peon_negro[64] = {
	  0,   0,   0,   0,   0,   0,   0,   0,
	  0,   0,   0,  -5,  -5,   0,   0,   0,
	  1,   2,   3,   4,   4,   3,   2,   1,
	  2,   4,   6,   8,   8,   6,   4,   2,
	  3,   6,   9,  12,  12,   9,   6,   3,
	  4,   8,  12,  16,  16,  12,   8,   4,
	  5,  10,  15,  20,  20,  15,  10,   5,
	  0,   0,   0,   0,   0,   0,   0,   0
};

int caballo_blanco[64] = {
       -15,  -9,  -6,  -6,  -6,  -6,  -9, -15,
       -10,  -2,   0,   1,   1,   0,  -2, -10,
        -6,   0,   5,   6,   6,   5,   0,  -6,
        -6,   0,   6,   8,   8,   6,   0,  -6,
        -6,   0,   5,   6,   6,   5,   0,  -6,
        -6,   0,   4,   5,   5,   4,   0,  -6,
		-9,  -2,   0,   1,   1,   0,  -2,  -9,
       -15,  -9,  -6,  -6,  -6,  -6,  -9, -15,
};

int caballo_negro[64] = {
       -15,  -9,  -6,  -6,  -6,  -6,  -9, -15,
        -9,  -2,   0,   1,   1,   0,  -2,  -9,
        -6,   0,   4,   5,   5,   4,   0,  -6,
        -6,   0,   5,   6,   6,   5,   0,  -6,
        -6,   0,   6,   8,   8,   6,   0,  -6,
        -6,   0,   5,   6,   6,   5,   0,  -6,
	   -10,  -2,   0,   1,   1,   0,  -2, -10,
       -15,  -9,  -6,  -6,  -6,  -6,  -9, -15,
};

int alfil_blanco[64] = {
         0,   2,   0,   0,   0,   0,   2,   0,       
         0,   4,   3,   2,   2,   3,   4,   0,  
         2,   4,   7,   5,   5,   7,   4,   2,
         2,   5,   7,   8,   8,   7,   5,   2,
         2,   5,   7,   8,   8,   7,   5,   2,
         2,   4,   7,   5,   5,   7,   4,   2,		 
		 0,   6,   2,   0,   0,   2,   6,   0,
         2,   0,  -2,  -4,  -4,  -2,   0,   2,
};

int alfil_negro[64] = {
         2,   0,  -2,  -4,  -4,  -2,   0,   2,
		 0,   6,   2,   0,   0,   2,   6,   0,
         2,   4,   7,   5,   5,   7,   4,   2,		 
         2,   5,   7,   8,   8,   7,   5,   2,
         2,   5,   7,   8,   8,   7,   5,   2,
         2,   4,   7,   5,   5,   7,   4,   2,
         0,   4,   3,   2,   2,   3,   4,   0,  
         0,   2,   0,   0,   0,   0,   2,   0,       
};

int torre_blanca[64] = { 
         4,   6,   8,  10,  10,   8,   6,   4,
         8,  10,  12,  14,  14,  12,  10,   8,
         4,   6,   8,  10,  10,   8,   6,   6,
        -1,   1,   3,   5,   5,   3,   1,  -1,
        -1,   1,   3,   5,   5,   3,   1,  -1,
        -1,   1,   3,   5,   5,   3,   1,  -1,
        -1,   1,   3,   5,   5,   3,   1,  -1,
        -1,   1,   3,   5,   5,   3,   1,  -1,
};

int torre_negra[64] = {
        -1,   1,   3,   5,   5,   3,   1,  -1,
        -1,   1,   3,   5,   5,   3,   1,  -1,
        -1,   1,   3,   5,   5,   3,   1,  -1,
        -1,   1,   3,   5,   5,   3,   1,  -1,
        -1,   1,   3,   5,   5,   3,   1,  -1,
         4,   6,   8,  10,  10,   8,   6,   6,
         8,  10,  12,  14,  14,  12,  10,   8,
         4,   6,   8,  10,  10,   8,   6,   4,

};

int dama_blanca[64] = {
        -2,   0,   2,   3,   3,   2,   0,  -2,
         2,   4,   6,   7,   7,   6,   4,   2,
         2,   4,   6,   7,   7,   6,   4,   2,
         1,   3,   5,   6,   6,   6,   5,   1,
         1,   2,   4,   5,   5,   4,   2,   1,
         0,   1,   3,   4,   4,   3,   1,   0,
        -2,   0,   2,   2,   2,   2,   0,  -2,
        -4,  -2,  -2,   0,   0,  -2,  -2,  -4,
};

int dama_negra[64] = {
        -4,  -2,  -2,   0,   0,  -2,  -2,  -4,
        -2,   0,   2,   2,   2,   2,   0,  -2,
         0,   1,   3,   4,   4,   3,   1,   0,
         1,   2,   4,   5,   5,   4,   2,   1,
         1,   3,   5,   6,   6,   6,   5,   1,
         2,   4,   6,   7,   7,   6,   4,   2,
         2,   4,   6,   7,   7,   6,   4,   2,
        -2,   0,   2,   3,   3,   2,   0,  -2,
};

int reyblanco_inicio[64] = {
	-55, -55, -89, -89, -89, -89, -55, -55,
	-34, -34, -55, -55, -55, -55, -34, -34,
	-21, -21, -34, -34, -34, -34, -21, -21,
	-13, -13, -21, -21, -21, -21, -13, -13,
	 -8,  -8, -13, -13, -13, -13,  -8,  -8,
	 -5,  -5,  -8,  -8,  -8,  -8,  -5,  -5,
	 -3,  -3,  -5,  -5,  -5,  -5,  -3,  -3,
	  2,  10,   4,   0,   0,   7,  10,   2
};

int reynegro_inicio[64] = {
	  2,  10,   4,   0,   0,   7,  10,   2
	 -3,  -3,  -5,  -5,  -5,  -5,  -3,  -3,
	 -5,  -5,  -8,  -8,  -8,  -8,  -5,  -5,
	 -8,  -8, -13, -13, -13, -13,  -8,  -8,
	-13, -13, -21, -21, -21, -21, -13, -13,
	-21, -21, -34, -34, -34, -34, -21, -21,
	-34, -34, -55, -55, -55, -55, -34, -34,
	-55, -55, -89, -89, -89, -89, -55, -55,
};

int rey_final[64] = {
	 -5,  -3,  -1,   0,   0,  -1,  -3,  -5,
	 -3,   5,   5,   5,   5,   5,   5,  -3,
	 -1,   5,  10,  10,  10,  10,   5,  -1,
	  0,   5,  10,  15,  15,  10,   5,   0,
	  0,   5,  10,  15,  15,  10,   5,   0,
	 -1,   5,  10,  10,  10,  10,   5,  -1,
	 -3,   5,   5,   5,   5,   5,   5,  -3,
	 -5,  -3,  -1,   0,   0,  -1,  -3,  -5,
};

// vector de simetra, utilizada para no repetir tablas de evaluacin para blanco-negro
int flip[64] = {
	 56,  57,  58,  59,  60,  61,  62,  63,
	 48,  49,  50,  51,  52,  53,  54,  55,
	 40,  41,  42,  43,  44,  45,  46,  47,
	 32,  33,  34,  35,  36,  37,  38,  39,
	 24,  25,  26,  27,  28,  29,  30,  31,
	 16,  17,  18,  19,  20,  21,  22,  23,
	  8,   9,  10,  11,  12,  13,  14,  15,
	  0,   1,   2,   3,   4,   5,   6,   7
};

/*una casilla del tablero puede ser blanca o negra, con esto sabemos si los alfiles
contrarios corren por la misma diagonal*/
int	colorcasilla[64] = {
		0, 1, 0, 1, 0, 1, 0, 1,
		1, 0, 1, 0, 1, 0, 1, 0,
		0, 1, 0, 1, 0, 1, 0, 1,
		1, 0, 1, 0, 1, 0, 1, 0,
		0, 1, 0, 1, 0, 1, 0, 1,
		1, 0, 1, 0, 1, 0, 1, 0,
		0, 1, 0, 1, 0, 1, 0, 1,
		1, 0, 1, 0, 1, 0, 1, 0,
	};

int malus_peones_doblados[64] = {
	0, 0, 0, 0, 0, 0, 0, 0,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	8, 8, 8,10,10, 8, 8, 8,
	0, 0, 0, 0, 0, 0, 0, 0
};

int malus_peones_aislados[64] = {
	0, 0, 0, 0, 0, 0, 0, 0,
   16,16,16,20,20,16,16,16,
   16,16,16,20,20,16,16,16,
   16,16,16,20,20,16,16,16,
   16,16,16,20,20,16,16,16,
   16,16,16,20,20,16,16,16,
   16,16,16,20,20,16,16,16,
	0, 0, 0, 0, 0, 0, 0, 0
};

int malus_peones_retrasados[64] = {
	0, 0, 0, 0, 0, 0, 0, 0,
    8,10,12,16,16,12,10, 8,
    8,10,12,16,16,12,10, 8,
    8,10,12,16,16,12,10, 8,
    8,10,12,16,16,12,10, 8,
    8,10,12,16,16,12,10, 8,
    8,10,12,16,16,12,10, 8,
	0, 0, 0, 0, 0, 0, 0, 0
};

int bonus_peones_pasados[64] = {
	 0,  0,  0,  0,  0,  0,  0,  0,
   120,120,120,120,120,120,120,120,
	90, 90, 90, 90, 90, 90, 90, 90,
	50, 50, 50, 50, 50, 50, 50, 50,
	30, 30, 30, 30, 30, 30, 30, 30,
	10, 10, 10, 10, 10, 10, 10, 10,
	10, 10, 10, 10, 10, 10, 10, 10,
	 0,  0,  0,  0,  0,  0,  0,  0
};

int bonus_duo[64] = {
	0, 0, 0, 0, 0, 0, 0, 0,
   10,10,10,10,10,10,10,10,
	6, 6, 6, 6, 6, 6, 6, 6,
	3, 3, 3, 3, 3, 3, 3, 3,
	2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2,
	0, 0, 0, 0, 0, 0, 0, 0
};

int sr_contador[64] = {
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 4, 4, 4, 4, 4, 4, 4,
	4, 3, 3, 3, 3, 3, 3, 4,
	2, 1, 1, 1, 1, 1, 1, 2,
	2, 0, 0, 0, 0, 0, 0, 2
};

int seguridad_rey[32] = {
    0,  1,  2,  4, 15, 30, 50, 60, 
	73, 85,100,125,150,175,200,225,
	250,275,300,325,350,375,400,425,
	450,475,500,525,550,575,600,600
};

static const int PAREJA_ALFILES[] = { 60, 60, 60, 60, 60, 55, 55, 50, 50,
                                       45, 45, 40, 40, 40, 40, 40, 40 };

int mov_caballo[9] = {
  -10, -4, 2, 8, 14, 18, 22, 24, 25
};

int mov_alfil[16] = {
  -20, -10, 0, 10, 20, 30, 38, 44, 48, 52, 54, 57, 58, 59, 60, 60
};

int mov_torre[16] = {
  -12, -8, -4, 0, 4, 8, 11, 14, 16, 18, 19, 20, 21, 22, 23, 24
};

int mov_torre_final[16] = {
  -20, -12, -4, 4, 12, 20, 28, 36, 44, 50, 54, 56, 57, 58, 59, 60
};

int mov_dama[32] = {
  -10, -8, -6, -4, -2, 0, 2, 4, 6, 8, 10, 12, 13, 14, 15, 16,
  16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16
};

int mov_dama_final[32] = {
  -20, -15, -10, -5, 0, 5, 10, 15, 19, 23, 27, 29, 30, 30, 30, 30,
  30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30
};

int peon_tropismo[9] = {0, 2, 1, 1, 0, 0, 0, 0, 0};

int torre_tropismo[9] = {0, 2, 2, 1, 0, 0, 0, 0, 0};

int caballo_tropismo[9] = {0, 2, 2, 2, 0, 0, 0, 0, 0};

int dama_tropismo[9] = {0, 3, 2, 2, 1, 0, 0, 0, 0};

int outpost[64] = {
	  0,  0,  0,  0,  0,  0,  0,  0,
	  0,  0,  0,  0,  0,  0,  0,  0,
	  0,  0,  0,  2,  2,  0,  0,  0,
	  0,  0,  3,  4,  4,  3,  0,  0,
	  0,  0,  3,  4,  4,  3,  0,  0,
	  0,  0,  0,  1,  1,  0,  0,  0,
	  0,  0,  0,  0,  0,  0,  0,  0,
	  0,  0,  0,  0,  0,  0,  0,  0
};

//Evaluacin completa de la posicin con salida mediante lazy eval
int	Evaluar(int alpha, int beta)
{
	int i, mat, x;

	material = piezasblanco+piezasnegro+peonesblanco+peonesnegro;
	
	if (material > FINAL) { // si no estamos en el final
		Evalua_material();
		// Lazy Eval
		/*si tenemos mucha ventaja o desventaja no hace falta seguir evaluando*/
    	if (turno == BLANCO)
    		mat = puntosblanco-puntosnegro;
    	else
    		mat = puntosnegro-puntosblanco;
    	if (mat - 150 >= beta)
    		return beta;
    	if (mat + 150 <= alpha)
    		return alpha;

		// ETables
		x = probe_eval();
		if (x != -MATE)
			return x;
		
		Busca_peones();
		Evalua_posicion_mediojuego();	//evaluamos material, posicin, estructura de poeones y seguridad del rey
		Evalua_peones_bloqueados();	//penalizamos si no tenemos las piezas desarrolladas

		//pareja de alfiles
		if (alfilesblancos == 2) {
			puntosblanco += PAREJA_ALFILES[peonesblancos + peonesnegros];
			if (alfilesnegros == 0) {
				puntosblanco += 20;
				if (caballosnegros == 0)
					puntosblanco += 10;
			}
		}
		if (alfilesnegros == 2) {
			puntosnegro += PAREJA_ALFILES[peonesblancos + peonesnegros];
			if (alfilesblancos == 0) {
				puntosnegro += 20;
				if (caballosblancos == 0)
					puntosnegro += 10;
			}
		}

		Evalua_alfiles_atrapados();	//evaluamos si un alfil se queda atrapado
		Evalua_caballos_atrapados(); //evaluamos si un caballo se queda atrapado
		Cambios_mediojuego();

		Evalua_seguridad_rey();
	}
	else {	// si estamos en el final

		/*
		BitBases
		*/
#if defined USE_EGBB

		int total_piezas = peonesblancos + caballosblancos + alfilesblancos + torresblancas + damasblancas + peonesnegros + caballosnegros + alfilesnegros + torresnegras + damasnegras;
		
		if(egbb_is_loaded && total_piezas <= 2) {

			int total_pieces;
			int player;
			int w_ksq;
			int b_ksq;
			int egbb_piece[32];
			int egbb_square[32];
	
			player = 1-turno; 
			total_pieces = 0;
			egbb_piece[0] = 0;
			egbb_piece[1] = 0;
			egbb_square[0] = 0;
			egbb_square[1] = 0;

			for (i = 0; i < 64; ++i) {
				if (color[i] == VACIO)
					continue;

			//TSCP uses A8 = 0, H1 = 63 but we use A1 = 0, H8 = 63
		
#define FLIP(sq) ((sq) ^ 0x38)

#define ADD_PIECE(type) {\
	    egbb_piece[total_pieces] = type;\
	    egbb_square[total_pieces] = FLIP(i);\
        total_pieces++;\
};
				if(egbb_is_loaded) {
					if(color[i] == BLANCO) {
						switch (pieza[i]) {
						case PEON: ADD_PIECE(_WPAWN); break;
						case CABALLO: ADD_PIECE(_WKNIGHT); break;
						case ALFIL: ADD_PIECE(_WBISHOP); break;
						case TORRE: ADD_PIECE(_WROOK); break;
						case DAMA: ADD_PIECE(_WQUEEN); break;
						case REY: w_ksq = FLIP(i); break;
						}
					} else {
						switch(pieza[i]) {
						case PEON: ADD_PIECE(_BPAWN); break;
						case CABALLO: ADD_PIECE(_BKNIGHT); break;
						case ALFIL: ADD_PIECE(_BBISHOP); break;
						case TORRE: ADD_PIECE(_BROOK); break;
						case DAMA: ADD_PIECE(_BQUEEN); break;
						case REY: b_ksq = FLIP(i); break;
						}
					}
				}
			}

			int score = probe_egbb(player,w_ksq,b_ksq,egbb_piece[0],egbb_square[0],egbb_piece[1],egbb_square[1]);
	
			if(score != _NOTFOUND)
				return score;
		}
#endif
		/*
		End bitbases
		*/

		// evaluamos otros finales que estn en las bitbases como tablas
		if (!peonesblancos && !peonesnegros) {
			if (!damasblancas && !damasnegras) { 
				if (!torresblancas && !torresnegras) { 
					if (!alfilesblancos && !alfilesnegros) { 
						if (caballosblancos <= 2 && caballosnegros <= 2) { //solo caballos
							return 0;
						}
					}
					else if (!caballosblancos && !caballosnegros) { 
						if (abs(alfilesblancos - alfilesnegros) <= 1) { //solo alfiles
							return 0;
						}
					}
				}
				if (torresblancas == 1 && torresnegras == 1) {
					if ((caballosblancos + alfilesblancos) <= 1 && (caballosnegros + alfilesnegros) <= 1) {
						return 0; //torre (+piezamenor) contra torre (+piezamenor)
					}
				}
				else if (torresblancas == 1 && !torresnegras) {	//torre contra 2 piezas
					if ((caballosblancos + alfilesblancos) == 0 && (caballosnegros + alfilesnegros) == 2) {
						return 0;
					}
				}
				else if (torresnegras == 1 && !torresblancas) {
					if ((caballosnegros + alfilesnegros) == 0 && (caballosblancos + alfilesblancos) == 2) {
						return 0;
					}
				}
			}
		}

		// ETables
		x = probe_eval();
		if (x != -MATE)
			return x;

		Evalua_material();
		Busca_peones();
		Evalua_posicion_final();	//evaluamos material, posicin, estructuras de peones y no evaluamos seguridad del rey

		//alfiles opuestos
		if (alfilesblancos == 1 && alfilesnegros == 1) {
			if (!damasblancas && !damasnegras && !torresblancas && !torresnegras && !caballosblancos && !caballosnegros) {
				if (peonesblancos + peonesnegros <= 6) {
   					int wbcolor, bbcolor;
					for (i = 0; i < 64; i++) { 
						if ((color[i] == BLANCO) && (pieza[i] == ALFIL))
							wbcolor = colorcasilla[i];
						if ((color[i] == NEGRO) && (pieza[i] == ALFIL))
							bbcolor = colorcasilla[i];
					}
					if (wbcolor != bbcolor) {
						if (turno == BLANCO) 
							return ((puntosblanco-puntosnegro) * (peonesblancos + peonesnegros) / 6);
						else
							return ((puntosnegro-puntosblanco) * (peonesblancos + peonesnegros) / 6);
					}
				}
			}
		}

		//pareja de alfiles en el final
		if (alfilesblancos == 2) {
			if ((piezasblanco == 2*VALOR_ALFIL) && (piezasnegro == 2*VALOR_CABALLO))
				puntosblanco += 0;
			else 
			{
				puntosblanco += PAREJA_ALFILES[peonesblancos + peonesnegros];
				if (alfilesnegros == 0) {
					puntosblanco += 20;
					if (caballosnegros == 0)
						puntosblanco += 10;
				}
			}
		}
		if (alfilesnegros == 2) {
			if ((piezasblanco == 2*VALOR_CABALLO) && (piezasnegro == 2*VALOR_ALFIL))
				puntosnegro += 0;
			else 
			{
				puntosnegro += PAREJA_ALFILES[peonesblancos + peonesnegros];
				if (alfilesblancos == 0) {
					puntosnegro += 20;
					if (caballosblancos == 0)
						puntosnegro += 10;
				}
			}
		}

		Evalua_alfiles_atrapados();	//evaluamos si un alfil se queda atrapado
		Evalua_caballos_atrapados(); //evaluamos si un caballo se queda atrapado
		Cambios_final();
	}

	//ajustamos el signo de la evaluacin segn el turno
	if (turno == BLANCO)
		x = puntosblanco-puntosnegro;
	else
		x = puntosnegro-puntosblanco;

	// ETables
	store_eval(x);

	return x;
}

/* convertimos el nmero de piezas a valor de piezas */
void Calcula_material()
{
	piezasblanco = VALOR_CABALLO*caballosblancos + VALOR_ALFIL*alfilesblancos + VALOR_TORRE*torresblancas + VALOR_DAMA*damasblancas;
	piezasnegro = VALOR_CABALLO*caballosnegros + VALOR_ALFIL*alfilesnegros + VALOR_TORRE*torresnegras + VALOR_DAMA*damasnegras;
	peonesblanco = VALOR_PEON*peonesblancos;
	peonesnegro = VALOR_PEON*peonesnegros;
}

/* valor total para las blancas o para las negras */
void Evalua_material()
{
	puntosblanco = piezasblanco + peonesblanco;
	puntosnegro = piezasnegro + peonesnegro;
}

// estructura de peones
void Busca_peones()
{
    int i,c;
	
	for (i = 0; i < 10; ++i) {
		fila_peon[BLANCO][i] = 0;
		fila_peon[NEGRO][i] = 7;
	}

   	for (i = 0; i < 64; i++) { //primera vuelta, comprobamos solo material
		if (color[i] == VACIO)
			continue;
        if (color[i] == BLANCO) {
			switch (pieza[i]) {
				case PEON:
					c = COLUMNA(i) + 1;
					if (fila_peon[BLANCO][c] < FILA(i))
						fila_peon[BLANCO][c] = FILA(i);
					break;
			}
		}
		else  {
			switch (pieza[i]) {
				case PEON:
					c = COLUMNA(i) + 1;
					if (fila_peon[NEGRO][c] > FILA(i))
						fila_peon[NEGRO][c] = FILA(i);
					break;
			}
		}
	}
}

/*evalua los peones blancos sobre una columna f, para comprobar la seguridad del rey,
basado en TSCP*/
int bpf(int f)
{
	int r = 0;

	if (fila_peon[BLANCO][f] == 6);  //el peon no ha sido movido
	else if (fila_peon[BLANCO][f] == 5)
		r -= 10;  //el peon ha sido adelantado una casilla
	else if (fila_peon[BLANCO][f] != 0)
		r -= 20;  //el peon ha sido adelantado ms de una casilla
	else
		r -= 25;  //no hay peon en esta columna

	if (fila_peon[NEGRO][f] == 7)
		r -= 15;  //no hay peon enemigo
	else if (fila_peon[NEGRO][f] == 5)
		r -= 10;  //el peon enemigo est en la tercera fila
	else if (fila_peon[NEGRO][f] == 4)
		r -= 5;   //el peon enemigo est en la cuarta fila

	return r;
}

//comprueba la seguridad del rey blanco
int rey_blanco(int sq)
{
	int r;  //el valor retornado
	int i;

	r = reyblanco_inicio[sq];

	//comprobamos si hay enroque largo o corto y as solo estudiamos las columnas correspondientes
	if (COLUMNA(sq) < 3) {
		r += bpf(1);
		r += bpf(2);
		r += bpf(3) / 2;  
	}
	else if (COLUMNA(sq) > 4) {
		r += bpf(8);
		r += bpf(7);
		r += bpf(6) / 2;
	}

	//si hay una columna abierta cerca del rey penalizamos
	else {
		for (i = COLUMNA(sq); i <= COLUMNA(sq) + 2; ++i)
			if ((fila_peon[BLANCO][i] == 0) && (fila_peon[NEGRO][i] == 7))
				r -= 10;
	}

	//solo comprobamos seguridad del rey si el contrario tiene suficiente material
	r *= piezasnegro;
	r /= (2*VALOR_TORRE + 2*VALOR_CABALLO + 2*VALOR_ALFIL + VALOR_DAMA);

	return r;
}

int npf(int f)
{
	int r = 0;

	if (fila_peon[NEGRO][f] == 1);
	else if (fila_peon[NEGRO][f] == 2)
		r -= 10;
	else if (fila_peon[NEGRO][f] != 7)
		r -= 20;
	else
		r -= 25;

	if (fila_peon[BLANCO][f] == 0)
		r -= 15;
	else if (fila_peon[BLANCO][f] == 2)
		r -= 10;
	else if (fila_peon[BLANCO][f] == 3)
		r -= 5;

	return r;
}

int rey_negro(int sq)
{
	int r;
	int i;

	r = reynegro_inicio[sq];
	if (COLUMNA(sq) < 3) {
		r += npf(1);
		r += npf(2);
		r += npf(3) / 2;
	}
	else if (COLUMNA(sq) > 4) {
		r += npf(8);
		r += npf(7);
		r += npf(6) / 2;
	}
	else {
		for (i = COLUMNA(sq); i <= COLUMNA(sq) + 2; ++i)
			if ((fila_peon[BLANCO][i] == 0) && (fila_peon[NEGRO][i] == 7))
				r -= 10;
	}
	r *= piezasblanco;
	r /= (2*VALOR_TORRE + 2*VALOR_CABALLO + 2*VALOR_ALFIL + VALOR_DAMA);
	return r;
}

/*estructura de peones basada en la del programa TSCP*/
int peones_blancos(int i)
{
	int b;  /* el valor para retornar con turno blanco */
	int c;  /* la columna del peon */

	b = 0;
	c = COLUMNA(i) + 1;
	aislado = FALSO;

	b += peon_blanco[i];

	/* peon doblado */
	if (fila_peon[BLANCO][c] > FILA(i))
		b -= malus_peones_doblados[i];

	/* peon aislado */
	if ((fila_peon[BLANCO][c - 1] == 0) && (fila_peon[BLANCO][c + 1] == 0)) {
		b -= malus_peones_aislados[i];
		aislado = VERDADERO;
	}
	/* peon retrasado */
	else if ((fila_peon[BLANCO][c - 1] < FILA(i)) && (fila_peon[BLANCO][c + 1] < FILA(i))) {
		b -= malus_peones_retrasados[i];
	}

	/* peon pasado */
	if ((fila_peon[NEGRO][c - 1] >= FILA(i)) && (fila_peon[NEGRO][c] >= FILA(i)) && (fila_peon[NEGRO][c + 1] >= FILA(i))) {
		b += bonus_peones_pasados[i];
		if (!aislado)
			b += PEON_PASADO_NOAISLADO;
		if (material < FINAL)
			b += (distancia[i][rn] - distancia[i][rb])*2;
	}

	if (!aislado) {
		//peon duo
		if (fila_peon[BLANCO][c-1] == fila_peon[BLANCO][c])
			b += bonus_duo[i];
	}
	return b;
}

int peones_negros(int i)
{
	int n;  /* el valor para retornar con turno blanco */
	int c;  /* la columna del peon */

	n = 0;
	c = COLUMNA(i) + 1;
	aislado = FALSO;

	n += peon_negro[i];

	/* peon doblado */
	if (fila_peon[NEGRO][c] < FILA(i))
		n -= malus_peones_doblados[flip[i]];

	/* peon aislado */
	if ((fila_peon[NEGRO][c - 1] == 7) && (fila_peon[NEGRO][c + 1] == 7)){
		n -= malus_peones_aislados[flip[i]];
		aislado = VERDADERO;
	}
	/* peon retrasado */
	else if ((fila_peon[NEGRO][c - 1] > FILA(i)) && (fila_peon[NEGRO][c + 1] > FILA(i))) {
		n -= malus_peones_retrasados[flip[i]];
	}
	/* peon pasado */
	if ((fila_peon[BLANCO][c - 1] <= FILA(i)) && (fila_peon[BLANCO][c] <= FILA(i)) && (fila_peon[BLANCO][c + 1] <= FILA(i))) {
		n += bonus_peones_pasados[flip[i]];
		if (!aislado)
			n += PEON_PASADO_NOAISLADO;
		if (material < FINAL)
			n += (distancia[i][rb] - distancia[i][rn])*2;
	}

	if (!aislado) {
		//peon duo
		if (fila_peon[NEGRO][c-1] == fila_peon[NEGRO][c])
			n += bonus_duo[flip[i]];
	}
	return n;
}

/*evaluacin de la posicin en el final, evala la estructura de peones pero no evalua la
seguridad del rey*/
void Evalua_posicion_final()
{
	int i;

	for (i = 0; i < 64; i++) { // sumamos tablas de piezas
		if (color[i] == VACIO)
			continue;
        if (color[i] == BLANCO) {
			switch (pieza[i]) {
				case PEON:
					puntosblanco += peones_blancos(i);	//estructura de peones
					break;
				case CABALLO:
					puntosblanco += caballo_blanco[i];
					puntosblanco += Movilidad_Caballo(i);
					break;
				case ALFIL:
					puntosblanco += alfil_blanco[i];
					puntosblanco += Movilidad_Alfil(i);
					break;
				case TORRE:
					puntosblanco += torre_blanca[i];
					puntosblanco += Movilidad_Torre(i);
					if (FILA(i) == 1)	//torre en sptima
						puntosblanco += TORRE_EN_SEPTIMA;
					if (fila_peon[BLANCO][COLUMNA(i) + 1] == 0) {
						if (fila_peon[NEGRO][COLUMNA(i) + 1] == 7)
							puntosblanco += TORRE_COLUMNAABIERTA; //columna abierta
						else
							puntosblanco += TORRE_COLUMNASEMIABIERTA;	//columna semiabierta
					}
					break;
				case DAMA:
					puntosblanco += dama_blanca[i];
					puntosblanco += Movilidad_Dama(i);
					if (FILA(i) == 1) 
						puntosblanco += DAMA_EN_SEPTIMA;
					break;
				case REY:
					puntosblanco += rey_final[i];
					break;
			}
        }
		else {
			switch (pieza[i]) {
				case PEON:
					puntosnegro += peones_negros(i);
					break;
				case CABALLO:
					puntosnegro += caballo_negro[i];
					puntosnegro += Movilidad_Caballo(i);
					break;
				case ALFIL:
					puntosnegro += alfil_negro[i];
					puntosnegro += Movilidad_Alfil(i);
					break;
				case TORRE:
					puntosnegro += torre_negra[i];
					puntosnegro += Movilidad_Torre(i);
					if (FILA(i) == 6)
						puntosnegro += TORRE_EN_SEPTIMA;
					if (fila_peon[NEGRO][COLUMNA(i) + 1] == 7) {
						if (fila_peon[BLANCO][COLUMNA(i) + 1] == 0)
							puntosnegro += TORRE_COLUMNAABIERTA;
						else
							puntosnegro += TORRE_COLUMNASEMIABIERTA;
					}
					break;
				case DAMA:
					puntosnegro += dama_negra[i];
					puntosnegro += Movilidad_Dama(i);
					if (FILA(i) == 6) 
						puntosnegro += DAMA_EN_SEPTIMA;
					break;
				case REY:
					puntosnegro += rey_final[i];
					break;
			}
		}
	}
}


/*evaluacin de la posicin para la apertura y medio juego, evalua la estrcutura de peones
y la seguridad del rey*/
void Evalua_posicion_mediojuego()
{
	int i;

	for (i = 0; i < 64; i++) { // sumamos tablas de piezas
		if (color[i] == VACIO)
			continue;
        if (color[i] == BLANCO) {
			switch (pieza[i]) {
				case PEON:
					puntosblanco += peones_blancos(i);	//estructura de peones
					if (i == 51 || i == 52)
						puntosblanco += DESARROLLO_LENTO * 2;
					puntosblanco += peon_tropismo[distancia[i][rn]];
					break;
				case CABALLO:
					puntosblanco += caballo_blanco[i];
					puntosblanco += Movilidad_Caballo(i);
					if (i == 57 || i == 62)
						puntosblanco += DESARROLLO_LENTO;
					if (outpost[i]) {
						if ((fila_peon[NEGRO][COLUMNA(i) + 2] == 7 || fila_peon[NEGRO][COLUMNA(i) + 2] >= FILA(i))
							&&
							(fila_peon[NEGRO][COLUMNA(i)] == 7 || fila_peon[NEGRO][COLUMNA(i)] >= FILA(i))) {
							puntosblanco += outpost[i];
						}
					puntosblanco += caballo_tropismo[distancia[i][rn]];
					break;
				case ALFIL:
					puntosblanco += alfil_blanco[i];
					puntosblanco += Movilidad_Alfil(i);
					if (i == 58 || i == 61)
						puntosblanco += DESARROLLO_LENTO;
					break;
				case TORRE:
					puntosblanco += torre_blanca[i];
					puntosblanco += Movilidad_Torre(i);
					if (FILA(i) == 1)	//torre en sptima
						puntosblanco += TORRE_EN_SEPTIMA/2;	//no valoramos tanto como en el final
					if (fila_peon[BLANCO][COLUMNA(i) + 1] == 0) {
						if (fila_peon[NEGRO][COLUMNA(i) + 1] == 7)
							puntosblanco += TORRE_COLUMNAABIERTA; //columna abierta
						else
							puntosblanco += TORRE_COLUMNASEMIABIERTA;	//columna semiabierta
					}
					if ((rb == 58 || rb == 57) && (i == 56 || i == 48 || i == 57))
						puntosblanco += TORRE_ATRAPADA;
					if ((rb == 61 || rb == 62) && (i == 63 || i == 55 || i == 62))
						puntosblanco += TORRE_ATRAPADA;
					puntosblanco += torre_tropismo[distancia[i][rn]];
					break;
				case DAMA:
					puntosblanco += dama_blanca[i];
					puntosblanco += Movilidad_Dama(i);
					if (i != 59 &&
						((color[57] == BLANCO && pieza[57] == CABALLO) ||
						(color[58] == BLANCO && pieza[58] == ALFIL) ||
							  (color[61] == BLANCO && pieza[61] == ALFIL) ||
							  (color[62] == BLANCO && pieza[62] == CABALLO)))
							puntosblanco += DAMA_PREMATURA;
					}
					puntosblanco += dama_tropismo[distancia[i][rn]];
					if (FILA(i) == 1) 
						puntosblanco += DAMA_EN_SEPTIMA;
					break;
				case REY:
					if ((COLUMNA(i) < 3 && (color[56] != BLANCO && pieza[56] != TORRE)) ||
						(COLUMNA(i) > 4 && (color[63] != BLANCO && pieza[63] != TORRE)))
						puntosblanco += REY_ENROCADO;
					puntosblanco += rey_blanco(i);
					break;
			}
        }
		else {
			switch (pieza[i]) {
				case PEON:
					puntosnegro += peones_negros(i);
					if (i == 11 || i == 12)
						puntosnegro += DESARROLLO_LENTO * 2;
					puntosnegro += peon_tropismo[distancia[i][rb]];
					break;
				case CABALLO:
					puntosnegro += caballo_negro[i];
					puntosnegro += Movilidad_Caballo(i);
					if (i == 1 || i == 6)
						puntosnegro += DESARROLLO_LENTO;
					if (outpost[i]) {
						if ((fila_peon[BLANCO][COLUMNA(i) + 2] == 7 || fila_peon[BLANCO][COLUMNA(i) + 2] <= FILA(i))
							&&
							(fila_peon[BLANCO][COLUMNA(i)] == 7 || fila_peon[BLANCO][COLUMNA(i)] <= FILA(i))) {
							puntosnegro += outpost[flip[i]];
						}
					puntosnegro += caballo_tropismo[distancia[i][rb]];
					break;
				case ALFIL:
					puntosnegro += alfil_negro[i];
					puntosnegro += Movilidad_Alfil(i);
					if (i == 2 || i == 5)
						puntosnegro += DESARROLLO_LENTO;
					break;
				case TORRE:
					puntosnegro += torre_negra[i];
					puntosnegro += Movilidad_Torre(i);
					if (FILA(i) == 6)
						puntosnegro += TORRE_EN_SEPTIMA/2;
					if (fila_peon[NEGRO][COLUMNA(i) + 1] == 7) {
						if (fila_peon[BLANCO][COLUMNA(i) + 1] == 0)
							puntosnegro += TORRE_COLUMNAABIERTA;
						else
							puntosnegro += TORRE_COLUMNASEMIABIERTA;
					}
					if ((rn == 2 || rn == 1) && (i == 0 || i == 8 || i == 1))
						puntosnegro += TORRE_ATRAPADA;
					if ((rn == 5 || rn == 6) && (i == 7 || i == 15 || i == 6))
						puntosnegro += TORRE_ATRAPADA;
					puntosnegro += torre_tropismo[distancia[i][rb]];
					break;
				case DAMA:
					puntosnegro += dama_negra[i];
					puntosnegro += Movilidad_Dama(i);
					if (i != 3 &&
						((color[1] == NEGRO && pieza[1] == CABALLO) ||
						(color[2] == NEGRO && pieza[2] == ALFIL) ||
						(color[5] == NEGRO && pieza[5] == ALFIL) ||
						(color[6] == NEGRO && pieza[6] == CABALLO)))
						puntosnegro += DAMA_PREMATURA;
					}
					puntosnegro += dama_tropismo[distancia[i][rb]];
					if (FILA(i) == 6) 
						puntosnegro += DAMA_EN_SEPTIMA;
					break;
				case REY:
					if ((COLUMNA(i) < 3 && (color[0] != NEGRO && pieza[0] != TORRE)) ||
						(COLUMNA(i) > 4 && (color[7] != NEGRO && pieza[7] != TORRE)))
						puntosnegro += REY_ENROCADO;
					puntosnegro += rey_negro(i);
					break;
			}
		}
	}
}

void Evalua_peones_bloqueados()
{
	//penaliza peones d2 y e2, d7 y e7 bloqueados
	if (pieza[51] == PEON && color[51] == BLANCO && color[43] != VACIO)
		puntosblanco += PEON_BLOQUEADO;
	if (pieza[52] == PEON && color[52] == BLANCO && color[44] != VACIO)
		puntosblanco += PEON_BLOQUEADO;
	if (pieza[11] == PEON && color[11] == NEGRO && color[19] != VACIO)
		puntosnegro += PEON_BLOQUEADO;
	if (pieza[12] == PEON && color[12] == NEGRO && color[20] != VACIO)
		puntosnegro += PEON_BLOQUEADO;
}

void Evalua_alfiles_atrapados()
{
	//alfiles encerrados en A2, A7, H2, H7, B1, B8, G1, G8
	if (((pieza[48] == ALFIL && color[48] == NEGRO) || (pieza[57] == ALFIL && color[57] == NEGRO))
		&& (pieza[41] == PEON && color[41] == BLANCO) && (pieza[50] == PEON && color[50] == BLANCO)) {
			puntosnegro += ALFIL_ATRAPADO;
	}
	if (((pieza[55] == ALFIL && color[55] == NEGRO) || (pieza[62] == ALFIL && color[62] == NEGRO))
		&& (pieza[46] == PEON && color[46] == BLANCO) && (pieza[53] == PEON && color[53] == BLANCO)) {
			puntosnegro += ALFIL_ATRAPADO;
	}
	if (((pieza[8] == ALFIL && color[8] == BLANCO) || (pieza[1] == ALFIL && color[1] == BLANCO))
		&& (pieza[17] == PEON && color[17] == NEGRO) && (pieza[10] == PEON && color[10] == NEGRO)) {
			puntosblanco += ALFIL_ATRAPADO;
	}
	if (((pieza[15] == ALFIL && color[15] == BLANCO) || (pieza[6] == ALFIL && color[6] == BLANCO))
		&& (pieza[22] == PEON && color[22] == NEGRO) && (pieza[13] == PEON && color[13] == NEGRO)) {
			puntosblanco += ALFIL_ATRAPADO;
	}
}

void Evalua_caballos_atrapados()
{
	//caballos semi-atrapados en A2, A7, H2, H7
	if (pieza[48] == CABALLO && color[48] == NEGRO && pieza[49] == PEON && color[49] == BLANCO && pieza[42] == PEON && color[42] == BLANCO)
		puntosnegro += CABALLO_ATRAPADO;
	if (pieza[55] == CABALLO && color[55] == NEGRO && pieza[54] == PEON && color[54] == BLANCO && pieza[45] == PEON && color[45] == BLANCO)
		puntosnegro += CABALLO_ATRAPADO;
	if (pieza[8] == CABALLO && color[8] == BLANCO && pieza[9] == PEON && color[9] == NEGRO && pieza[18] == PEON && color[18] == NEGRO)
		puntosblanco += CABALLO_ATRAPADO;
	if (pieza[15] == CABALLO && color[15] == BLANCO && pieza[14] == PEON && color[14] == NEGRO && pieza[21] == PEON && color[21] == NEGRO)
		puntosblanco += CABALLO_ATRAPADO;
	//caballos semi-atrapados en A1, A8, H1, H8
	if ((pieza[56] == CABALLO && color[56] == NEGRO) && ((pieza[48] == PEON && color[48] == BLANCO) || (pieza[50] == PEON && color[50] == BLANCO)))
		puntosnegro += CABALLO_ATRAPADO/2;
	if ((pieza[63] == CABALLO && color[63] == NEGRO) && ((pieza[55] == PEON && color[55] == BLANCO) || (pieza[53] == PEON && color[53] == BLANCO)))
		puntosnegro += CABALLO_ATRAPADO/2;
	if ((pieza[0] == CABALLO && color[0] == BLANCO) && ((pieza[8] == PEON && color[8] == NEGRO) || (pieza[10] == PEON && color[10] == NEGRO)))
		puntosblanco += CABALLO_ATRAPADO/2;
	if ((pieza[7] == CABALLO && color[7] == BLANCO) && ((pieza[15] == PEON && color[15] == NEGRO) || (pieza[13] == PEON && color[13] == NEGRO)))
		puntosblanco += CABALLO_ATRAPADO/2;
}

void Cambios_mediojuego()
{
	int temp1, temp2;

	temp1 = piezasblanco - piezasnegro;
	temp2 = alfilesblancos + caballosblancos - alfilesnegros - caballosnegros;
	
	if (temp1 >= VALOR_TORRE) puntosblanco += 200;			// mayor contra peones
	else if (temp1 <= -VALOR_TORRE) puntosnegro += 200;
	else if (temp1 >= VALOR_CABALLO) puntosblanco += 100;		// menor contra peones
	else if (temp1 <= -VALOR_CABALLO) puntosnegro += 100;
	else if (temp1 >= (VALOR_TORRE-VALOR_ALFIL)) puntosblanco += 25;		// menor contra torre
	else if (temp1 <= -(VALOR_TORRE-VALOR_ALFIL)) puntosnegro += 25;
	else if (temp2 >= 3) puntosblanco += 75;		// tres menores contra dama o dos torres
	else if (temp2 <= -3) puntosnegro += 75;
	else if (temp2 == 2) puntosblanco += 50;		// dos menores contra torre
	else if (temp2 == -2) puntosnegro += 50;

	if (damasblancas && !damasnegras) puntosblanco += 75;	//bonus por tener dama
	else if(damasnegras && !damasblancas) puntosnegro += 75;
}

void Cambios_final()
{
	int temp1, temp2;

	temp1 = piezasblanco - piezasnegro;
	temp2 = alfilesblancos + caballosblancos - alfilesnegros - caballosnegros;
	
	if (temp1 >= VALOR_CABALLO) puntosblanco += 50;			// menor contra peones
	else if (temp1 <= -VALOR_CABALLO) puntosnegro += 50;
	else if (temp1 >= (VALOR_TORRE-VALOR_ALFIL)) puntosblanco -= 25;		// menor contra torre
	else if (temp1 <= -(VALOR_TORRE-VALOR_ALFIL)) puntosnegro -= 25;
	else if (temp2 >= 3) puntosblanco += 25;		// tres menores contra dama o dos torres
	else if (temp2 <= -3) puntosnegro += 25;

	if (damasblancas && !damasnegras) puntosblanco += 25;	//bonus por tener dama
	else if(damasnegras && !damasblancas) puntosnegro += 25;
}

void Evalua_seguridad_rey()
{
	int l, atacadasb, atacadasn;

	atacadasb = sr_contador[rb];
	atacadasn = sr_contador[flip[rn]];

	if (damasnegras >= 1) {

		l = rb + 9;
		if (l <= 63 && COLUMNA(l) > COLUMNA(rb) && atacado(l, BLANCO)) {
			atacadasb++;
			if (!atacado_nr(l, NEGRO)) atacadasb++;
		}
		l = rb + 8;
		if (l <= 63 && atacado(l, BLANCO)) {
			atacadasb++;
			if (!atacado_nr(l, NEGRO)) atacadasb++;
		}
		l = rb + 7;
		if (l <= 63 && COLUMNA(l) < COLUMNA(rb) && atacado(l, BLANCO)) {
			atacadasb++;
			if (!atacado_nr(l, NEGRO)) atacadasb++;
		}
		l = rb - 1;
		if (FILA(l) == FILA(rb) && atacado(l, BLANCO)) {
			atacadasb++;
			if (!atacado_nr(l, NEGRO)) atacadasb++;
		}
		l = rb + 1;
		if (FILA(l) == FILA(rb) && atacado(l, BLANCO)) {
			atacadasb++;
			if (!atacado_nr(l, NEGRO)) atacadasb++;
		}

		l = rb - 7;
		if (l >= 0 && COLUMNA(l) > COLUMNA(rb)) {
			if (atacado(l, BLANCO)) {
				atacadasb ++;
				if (color[l] != BLANCO) atacadasb += 2;
				else if (pieza[l] != PEON) atacadasb++;
				if (!atacado_nr(l, NEGRO)) atacadasb ++;
			}
			else if (color[l] != BLANCO) {
				atacadasb++;
			}
		}
		l = rb - 8;
		if (l >= 0) {
			if (atacado(l, BLANCO)) {
				atacadasb ++;
				if (color[l] != BLANCO) atacadasb += 2;
				else if (pieza[l] != PEON) atacadasb++;
				if (!atacado_nr(l, NEGRO)) atacadasb ++;
			}
			else if (color[l] != BLANCO) {
				atacadasb++;
			}
		}
		l = rb - 9;
		if (l >= 0 && COLUMNA(l) < COLUMNA(rb)) {
			if (atacado(l, BLANCO)) {
				atacadasb ++;
				if (color[l] != BLANCO) atacadasb += 2;
				else if (pieza[l] != PEON) atacadasb++;
				if (!atacado_nr(l, NEGRO)) atacadasb ++;
			}
			else if (color[l] != BLANCO) {
				atacadasb++;
			}
		}

		puntosnegro += seguridad_rey[atacadasb];
		if (atacado(rb, BLANCO))
			puntosnegro += 50;
	}

	if (damasblancas >= 1) {

		l = rn - 9;
		if (l >= 0 && COLUMNA(l) < COLUMNA(rn) && atacado(l, NEGRO)) {
			atacadasn++;
			if (!atacado_nr(l, BLANCO)) atacadasn++;
		}
		l = rn - 8;
		if (l >= 0 && atacado(l, NEGRO)) {
			atacadasn++;
			if (!atacado_nr(l, BLANCO)) atacadasn++;
		}
		l = rn - 7;
		if (l >= 0 && COLUMNA(l) > COLUMNA(rn) && atacado(l, NEGRO)) {
			atacadasn++;
			if (!atacado_nr(l, BLANCO)) atacadasn++;
		}
		l = rn - 1;
		if (FILA(l) == FILA(rn) && atacado(l, NEGRO)) {
			atacadasn++;
			if (!atacado_nr(l, BLANCO)) atacadasn++;
		}
		l = rn + 1;
		if (FILA(l) == FILA(rn) && atacado(l, NEGRO)) {
			atacadasn++;
			if (!atacado_nr(l, BLANCO)) atacadasn++;
		}

		l = rn + 7;
		if (l <= 63 && COLUMNA(l) < COLUMNA(rn)) {
			if (atacado(l, NEGRO)) {
				atacadasn ++;
				if (color[l] != NEGRO) atacadasn += 2;
				else if (pieza[l] != PEON) atacadasn++;
				if (!atacado_nr(l, BLANCO)) atacadasn ++;
			}
			else if (color[l] != NEGRO) {
				atacadasn++;
			}
		}
		l = rn + 8;
		if (l <= 63) {
			if (atacado(l, NEGRO)) {
				atacadasn ++;
				if (color[l] != NEGRO) atacadasn += 2;
				else if (pieza[l] != PEON) atacadasn++;
				if (!atacado_nr(l, BLANCO)) atacadasn ++;
			}
			else if (color[l] != NEGRO) {
				atacadasn++;
			}
		}
		l = rn + 9;
		if (l <= 63 && COLUMNA(l) > COLUMNA(rn)) {
			if (atacado(l, NEGRO)) {
				atacadasn ++;
				if (color[l] != NEGRO) atacadasn += 2;
				else if (pieza[l] != PEON) atacadasn++;
				if (!atacado_nr(l, BLANCO)) atacadasn ++;
			}
			else if (color[l] != NEGRO) {
				atacadasn++;
			}
		}

		puntosblanco += seguridad_rey[atacadasn];
		if (atacado(rn, NEGRO))
			puntosblanco += 50;

	}
}

int Movilidad_Caballo(int pos) 
{
	int l;
	int m = 0;

    l = pos - 17;
    if (l >= 0 && COLUMNA(l) < COLUMNA(pos) && pieza[l] == VACIO) m++;
    l = pos - 15;
    if (l >= 0 && COLUMNA(l) > COLUMNA(pos) && pieza[l] == VACIO) m++;

    l = pos - 10;
    if (l >= 0 && COLUMNA(l) < COLUMNA(pos) && pieza[l] == VACIO) m++;
    l = pos - 6;
    if (l >= 0 && COLUMNA(l) > COLUMNA(pos) && pieza[l] == VACIO) m++;

    l = pos + 6;
    if (l <= 63 && COLUMNA(l) < COLUMNA(pos) && pieza[l] == VACIO) m++;
    l = pos + 10;
    if (l <= 63 && COLUMNA(l) > COLUMNA(pos) && pieza[l] == VACIO) m++;		
		
    l = pos + 15;
    if (l <= 63 && COLUMNA(l) < COLUMNA(pos) && pieza[l] == VACIO) m++;
    l = pos + 17;
    if (l <= 63 && COLUMNA(l) > COLUMNA(pos) && pieza[l] == VACIO) m++;

	return mov_caballo[m];
}

int Movilidad_Alfil(int pos)
{
	int l;
	int m = 0;

	for (l = pos-9; ((l >= 0) && COLUMNA(l) < COLUMNA(pos) && pieza[l] == VACIO); l-=9)
		m++;
	for (l = pos-7; ((l >= 0) && COLUMNA(l) > COLUMNA(pos) && pieza[l] == VACIO); l-=7)
		m++;
	for (l = pos+7; ((l <= 63) && COLUMNA(l) < COLUMNA(pos) && pieza[l] == VACIO); l+=7)
		m++;
	for (l = pos+9; ((l <= 63) && COLUMNA(l) > COLUMNA(pos) && pieza[l] == VACIO); l+=9)
		m++;

	return mov_alfil[m];
}

int Movilidad_Torre(int pos) 
{
	int l;
	int m = 0;

	for (l = pos-8; ((l >= 0) && pieza[l] == VACIO); l-=8)
		m++;
	for (l = pos-1; ((FILA(l) == FILA(pos)) && pieza[l] == VACIO); l-=1)
		m++;
	for (l = pos+8; ((l <= 63) && pieza[l] == VACIO); l+=8)
		m++;
	for (l = pos+1; ((FILA(l) == FILA(pos)) && pieza[l] == VACIO); l+=1)
		m++;

	if (material > FINAL) return mov_torre[m];
	else return mov_torre_final[m];
}

int Movilidad_Dama(int pos) 
{
	int l;
	int m = 0;

	for (l = pos-9; ((l >= 0) && COLUMNA(l) < COLUMNA(pos) && pieza[l] == VACIO); l-=9)
		m++;
	for (l = pos-7; ((l >= 0) && COLUMNA(l) > COLUMNA(pos) && pieza[l] == VACIO); l-=7)
		m++;
	for (l = pos+7; ((l <= 63) && COLUMNA(l) < COLUMNA(pos) && pieza[l] == VACIO); l+=7)
		m++;
	for (l = pos+9; ((l <= 63) && COLUMNA(l) > COLUMNA(pos) && pieza[l] == VACIO); l+=9)
		m++;
	for (l = pos-8; ((l >= 0) && pieza[l] == VACIO); l-=8)
		m++;
	for (l = pos-1; ((FILA(l) == FILA(pos)) && pieza[l] == VACIO); l-=1)
		m++;
	for (l = pos+8; ((l <= 63) && pieza[l] == VACIO); l+=8)
		m++;
	for (l = pos+1; ((FILA(l) == FILA(pos)) && pieza[l] == VACIO); l+=1)
		m++;

	if (material > FINAL) return mov_dama[m];
	else return mov_dama_final[m];
}

/*esta funcin nos va a permitir reclamar tablas por una insuficiencia de material*/
int tablas()
{	
	int i;

	if (peonesblanco == 0 && peonesnegro == 0) {
		//podemos reclamar tablas cuando ambos bandos tienen menos material que una torre
		if ((piezasblanco < VALOR_TORRE) && (piezasnegro < VALOR_TORRE)) {
			//pero exceptuamos los siguientes casos
			//si cada uno de los bandos tiene un caballo
			if ((piezasblanco == VALOR_CABALLO) && (piezasnegro == VALOR_CABALLO))
				return FALSO;
			//si uno de los bandos tiene un alfil y el otro un caballo
			else if ((piezasblanco == VALOR_ALFIL) && (piezasnegro == VALOR_CABALLO))
				return FALSO;
			else if ((piezasblanco == VALOR_CABALLO) && (piezasnegro == VALOR_ALFIL))
				return FALSO;
			//si cada bando tiene un alfil pero son de distinto color
			else if ((piezasblanco == VALOR_ALFIL) && (piezasnegro == VALOR_ALFIL)) {
   				for (i = 0; i < 64; i++) { 
					if ((color[i] == BLANCO) && (pieza[i] == ALFIL))
						alfilblanco = colorcasilla[i];
					if ((color[i] == NEGRO) && (pieza[i] == ALFIL))
						alfilnegro = colorcasilla[i];
				}
				if (alfilblanco != alfilnegro)
					return FALSO;
				else
					return VERDADERO;
			}
			else
				return VERDADERO;
		}
		else
			return FALSO;
	}
	else 
		return FALSO;
}

//comprueba si una posicin se repite
int repeticion()
{
	int i;
	int r = 0;

	for (i = njugadas-regla50; i < njugadas; ++i)
		if (jugadas[i].hash == hash)
			++r;
	return r;
}
