/*

Motor de ajedrez xboard/winboard DanaSah
Pedro Castro

Funciones para manejar archivos del tipo fen

*/

void SetBoard(char *string) 
{
	char c;
	int sq=0, i=0, j=0;
	int	tpieza[26] = {6,2,6,6,6,6,6,6,6,6,5,6,6,1,6,0,4,3,6,6,6,6,6,6,6,6};

	/** Rellenamos la tabla de posiciones y colores **/
	while (sq < 64) {
		c = string[i++];
		if ('a'<c && c<'z') {
			color[sq] = NEGRO;
			pieza[sq] = tpieza[c - 'a'];
			sq++;
		}
		else if ('A'<c && c<'Z') {
			color[sq] = BLANCO;
			pieza[sq] = tpieza[c - 'A'];
			sq++;
		}
		else if ('1'<=c && c<='8') {
			for (j=0; j<(c - '0'); j++) {
				color[sq+j] = VACIO;
				pieza[sq+j] = VACIO;
			}
			sq += j;
		}
	}

	/***** Color para el turno *****/
	c = string[i++];
	if (c == 'w')		{ turno = BLANCO; motor = NEGRO; }
	else if (c == 'b')	{ turno = NEGRO; motor = BLANCO; }

	/***** Flag del enroque *****/
	enroque = 0;
	c = string[i++];
	while (c == 'K' || c == 'Q' || c == 'k' || c == 'q') {
		if (c == 'K') {
			enroque = enroque + 1;
		}
		if (c == 'Q') {
			enroque = enroque + 2;
		}
		if (c == 'k') {
			enroque = enroque + 4;
		}
		if (c == 'q') {
			enroque = enroque + 8;
		}
		c = string[i++];
	}
	/***** Flag de al paso *****/
	c = string[i++];
	if (c>='a' && c<='h') {
		alpaso = (c - 'a');
		c = string[i++];
		if (c>='1' && c<='8') alpaso += 8*(7-(c - '1'));
		else alpaso = -1;
	}
	else alpaso = -1;

	/***************************/
	regla50 = 0;	//inicamos la regla de los 50 movimientos
	njugadas = 0;	//ponemos a 0 el contador de jugadas

	/* al editar una posicin no utilizamos el libro ya que puede haber un extrao 
	problema que no permite iniciar el motor */
	usa_libro = FALSO;
	
	//calculamos el nmero de piezas que hay en el tablero y situacin de los reyes
	peonesblancos = peonesnegros = 0;
	caballosblancos = caballosnegros = 0;
	alfilesblancos = alfilesnegros = 0;
	torresblancas = torresnegras = 0;
	damasblancas = damasnegras = 0;

	for (i = 0; i < 64; i++) {
		if (color[i] == VACIO)
			continue;
        if (color[i] == BLANCO) {
			switch (pieza[i]) {
				case PEON:
					peonesblancos++;
					break;
				case CABALLO:
					caballosblancos++;
					break;
				case ALFIL:
					alfilesblancos++;
					break;
				case TORRE:
					torresblancas++;
					break;
				case DAMA:
					damasblancas++;
					break;
				case REY:
					rb = i;
					break;
			}
		}
		else  {
			switch (pieza[i]) {
				case PEON:
					peonesnegros++;
					break;
				case CABALLO:
					caballosnegros++;
					break;
				case ALFIL:
					alfilesnegros++;
					break;
				case TORRE:
					torresnegras++;
					break;
				case DAMA:
					damasnegras++;
					break;
				case REY:
					rn = i;
					break;
			}
		}
	}

	Calcula_material();

	poner_hash();
	clear_hash();

	for (i=0;i<64;i++) {
		for (j=0;j<64;j++) {
			distancia[i][j] = max(abs(FILA(j) - FILA(i)), abs(COLUMNA(j) - COLUMNA(i)));
		}
	}
}
