/*
Motor de ajedrez xboard/winboard DanaSah
Pedro Castro

Funciones que reciben informacin del GUI
*/

int Comprobar_Tipo_Movimiento(int de, int a, char *s)
{
	int tipo = NINGUNO;

	//comprueba si es correcto avanzar el peon 2 casillas
	if ((pieza[de] == PEON) && (color[de] == BLANCO)) 
		if ((s[1] == '2') && (s[3] == '4') && (color[de-8] == VACIO) && (color[a] == VACIO)) 
			tipo = PEON_AVANZA_2;
	if ((pieza[de] == PEON) && (color[de] == NEGRO))
		if ((s[1] == '7') && (s[3] == '5') && (color[de+8] == VACIO) && (color[a] == VACIO))
			tipo = PEON_AVANZA_2;

	//comprueba si se puede realizar un enroque
	if ((s[0] == 'e') && (s[1] == '1') && (s[2] == 'g') && (s[3] == '1'))
		if ((enroque & 1) && (color[61] == VACIO) && (color[62] == VACIO) && 
			(!atacado (60, BLANCO)) && (!atacado (61, BLANCO)))
			tipo = ENROQUE;
	if ((s[0] == 'e') && (s[1] == '1') && (s[2] == 'c') && (s[3] == '1'))
		if ((enroque & 2) && (color[59] == VACIO) && (color[58] == VACIO) && (color[57] == VACIO) && 
			(!atacado (60, BLANCO)) && (!atacado (59, BLANCO)))
			tipo = ENROQUE;
	if ((s[0] == 'e') && (s[1] == '8') && (s[2] == 'g') && (s[3] == '8'))
		if ((enroque & 4) && (color[5] == VACIO) && (color[6] == VACIO) && 
			(!atacado (4, NEGRO)) && (!atacado (5, NEGRO))) 
			tipo = ENROQUE;
	if ((s[0] == 'e') && (s[1] == '8') && (s[2] == 'c') && (s[3] == '8'))
		if ((enroque & 8) && (color[3] == VACIO) && (color[2] == VACIO) && (color[1] == VACIO) && 
			(!atacado (4, NEGRO)) && (!atacado (3, NEGRO)))
			tipo = ENROQUE;

	//comprueba si se puede realizar al paso
	if ((alpaso != -1) && (pieza[de] == PEON) && (a == alpaso))	{
		if ((COLUMNA(alpaso) != 0) && (color[alpaso + 7] == BLANCO) && (pieza[alpaso + 7] == PEON))
			tipo = AL_PASO;
		if ((COLUMNA(alpaso) != 7) && (color[alpaso + 9] == BLANCO) && (pieza[alpaso + 9] == PEON))
			tipo = AL_PASO;		
		if ((COLUMNA(alpaso) != 0) && (color[alpaso - 9] == NEGRO) && (pieza[alpaso - 9] == PEON))
			tipo = AL_PASO;		
		if ((COLUMNA(alpaso) != 7) && (color[alpaso - 7] == NEGRO) && (pieza[alpaso - 7] == PEON))
			tipo = AL_PASO;		
	}
	return tipo;
}

void Comprobar_Movimiento(char *s) 		//comprueba si llega un movimiento del usuario
{
	int de, a, tipo, i;
	int contar;
    movimiento	lista[218];

	//comprueba si estamos recibiendo un movimiento
	if (s[0] < 'a' || s[0] > 'h' ||
		s[1] < '0' || s[1] > '9' ||
		s[2] < 'a' || s[2] > 'h' ||
		s[3] < '0' || s[3] > '9') {
		printf("Error (unknown command): %s\n", s);
		return;
		}

	de = s[0] - 'a';
    de += 8 * (8 - (s[1] - '0'));
    a = s[2] - 'a';
    a += 8 * (8 - (s[3] - '0'));
	tipo = NORMAL;

	//comprueba si es correcto realizar una promocin
	if (pieza[de] == PEON && (a < 8 || a > 55)) {
		if (s[4] == 'q' || s[4] =='Q')
			tipo = PROMOCION_A_DAMA;
		else if (s[4] == 'r' || s[4] == 'R')
			tipo = PROMOCION_A_TORRE;
		else if (s[4] == 'b' || s[4] == 'B')
			tipo = PROMOCION_A_ALFIL;
		else if (s[4] == 'n' || s[4] == 'N')
			tipo = PROMOCION_A_CABALLO;
	}

	if (Comprobar_Tipo_Movimiento(de, a, s) != NINGUNO)
		tipo = Comprobar_Tipo_Movimiento(de, a, s);

	ply = 0;

    contar = Generar(turno, lista);
    /* recorre todos los movimientos para ver si es legal */
	for (i = 0; i < contar; i++) {
		if (lista[i].de == de && lista[i].a == a && lista[i].tipo == tipo) {
			if (Hacer_Movimiento(lista[i]))
				return;
			else {
				Deshacer();
				continue;
			}
		}
	}
	printf("Illegal move: %s\n", s);
	return;
}

int bioskey() // interrumpe la bsqueda al recibir el programa algo
{
   static int init = 0, pipe;
   static HANDLE inh;
   DWORD dw;

   if (!init) {
     init = 1;
     inh = GetStdHandle(STD_INPUT_HANDLE);
     pipe = !GetConsoleMode(inh, &dw);
     if (!pipe) {
        SetConsoleMode(inh, dw & ~(ENABLE_MOUSE_INPUT|ENABLE_WINDOW_INPUT));
        FlushConsoleInputBuffer(inh);
      }
    }
    if (pipe) {
      if (!PeekNamedPipe(inh, NULL, 0, NULL, &dw, NULL)) {
        return 1;
      }
      return dw;
    } else {
      GetNumberOfConsoleInputEvents(inh, &dw);
      return dw <= 1 ? 0 : dw;
	}
}
