/*
Motor de ajedrez xboard/winboard DanaSah
Pedro Castro

Iniciaciones
*/

void leer_inifile() 
{
	FILE *inifile;
	char linea[256], comandos[256], temp[256];
	char temp2[256] = "";
	int tamano1, tamano2;
  
	if ((inifile = fopen ("danasah.ini", "r")) == NULL) {
		printf("Ini file danasah.ini no found.\n");
		printf("DanaSah play without own opening book.\n");
		printf("Table hash size 16 Mb.\n");
		printf("Eval cache size 2 Mb.\n");
		TTSize = (16 * 1024 * 1024) / sizeof(TType);
		ETSize = (2 * 1024 * 1024) / sizeof(EType);
		alloc_hash();
		libroblanco[0] = '\0';
		libronegro[0] = '\0';
		return;
	}
	else {
		printf("Ini file danasah.ini found.\n");
		fseek(inifile, 0, SEEK_SET);
		while (fgets(linea, 256, inifile)) {
			if (linea[0] != '#') {
				sscanf(linea, "%s", &comandos);
				//Libro de aperturas que hay que abrir
				if (strcmp(comandos, "bookwhite") == 0) {
					sscanf(linea, "bookwhite %s", &temp);
					//printf("Light book: %s\n", temp);
					strcpy(libroblanco, temp);
				}
				if (strcmp(comandos, "bookblack") == 0) {
					sscanf(linea, "bookblack %s", &temp);
					//printf("Dark book: %s\n", temp);
					strcpy(libronegro, temp);
				}
				// Transposition table
				if (strcmp(comandos, "hash") == 0) {
					sscanf(linea, "hash %d", &tamano1);
					printf("Table hash size %d Mb.\n", tamano1);
					TTSize = (tamano1 * 1024 * 1024) / sizeof(TType);
				}
				// Eval cache
				if (strcmp(comandos, "ecache") == 0) {
					sscanf(linea, "ecache %d", &tamano2);
					printf("Eval cache size %d Mb.\n", tamano2);
					ETSize = (tamano2 * 1024 * 1024) / sizeof(EType);
				}
				// Bitbases
				if (strcmp(comandos, "path") == 0) {
					sscanf(linea, "path %s", &temp2);
					strcpy(egbb_path, temp2);
				}
			}
		}
		alloc_hash();
	}
	fclose(inifile);
	return;   
}

void IniciaTablero()	// iniciamos piezas y colores
{								
	int i, j;
	for (i = 0; i < 64; ++i) {
		color[i] = inicial_color[i];
		pieza[i] = inicial_pieza[i];
	}

	turno = BLANCO;		// inicialmente mueven las blancas
	motor = NEGRO;
    salir = FALSO;		// el motor dejar de pensar cuando reciba mate
	usa_libro = VERDADERO;	// utilizamos libro de aperturas
	
	njugadas = 0;		// iniciamos la lista de judadas
	regla50 = 0;		// ponemos a cero el contador de la regla de 50 movimientos
	max_profundidad = MAX_PROFUNDIDAD;	
	alpaso = -1;		// -1 no hay casilla al paso
	enroque = 15;		// 8+4+2+1 = 15 todas las posibilidades inicialmente
	
	// posiciones de los reyes
	rb = 60;
	rn = 4;

	// nmero de piezas iniciales
	peonesblancos = peonesnegros = 8;
	caballosblancos = caballosnegros = 2;
	alfilesblancos = alfilesnegros = 2;
	torresblancas = torresnegras = 2;
	damasblancas = damasnegras = 1;

	Calcula_material();

	poner_hash();
	clear_hash();

    // Distancia entre casillas
	for (i=0;i<64;i++) {
		for (j=0;j<64;j++) {
			distancia[i][j] = max(abs(FILA(j) - FILA(i)), abs(COLUMNA(j) - COLUMNA(i)));
		}
	}
}

// get_ms() nos indica la hora actual, utilizada para controlar tiempos (TSCP)
int ftime_ok = FALSO;
int get_ms()
{
	struct timeb timebuffer;
	ftime(&timebuffer);
	if (timebuffer.millitm != 0)
		ftime_ok = VERDADERO;
	return (timebuffer.time * 1000) + timebuffer.millitm;
}

/*
Bitbases
*/

#if defined USE_EGBB

PPROBE_EGBB probe_egbb;
int egbb_is_loaded;
typedef void (*PLOAD_EGBB) (char* path);

void LoadEgbbLibrary(char* main_path) {
	HMODULE hmod;
	PLOAD_EGBB load_egbb;
	char path[256];

	strcpy(path,main_path);
	strcat(path,"egbbdll.dll");
	if(hmod = LoadLibrary(path)) {
		load_egbb = (PLOAD_EGBB) GetProcAddress(hmod,"load_egbb");
		probe_egbb = (PPROBE_EGBB) GetProcAddress(hmod,"probe_egbb");
		load_egbb(main_path);
		egbb_is_loaded = 1;
	} else {
		egbb_is_loaded = 0;
	}
}

#endif
/*
EndBitbases
*/