/*
Motor de ajedrez xboard/winboard DanaSah
Version: 2.73
Pedro Castro

Funcin principal - main()
La funcin principal es bsicamente un bucle que espera recibir un comando xboard del
interface o GUI, una vez recibido pasa el control a la funcin xboard().
*/

// disable 'deprecated' warnings
#pragma warning(disable : 4996)
// disable 'macro redefinition' warnings
#pragma warning(disable : 4005)

//includes necesitados para algunas funciones de C.
#include <stdio.h>		//prinft, scanf, sprinft, sscanf, fgets...
#include <stdlib.h>		//rand, srand
#include <string.h>		//strcmp
#include <signal.h>		//xboard
#include <sys/timeb.h>	//ftime
#include <windows.h>	//bioskey()
#include <time.h>		//apertura aleatoria
/* -----------------------------------------------------------------*/
//el programa lo he dividido simplemente en varias archivos, aqu aado otras partes
//del programa.
#include "dandefs.h"		//constantes, variables y prototipos
#include "book.h"		//maneja el libro
#include "random.h"		//funciones para obtener un nmero aleatorio de 64 bits
#include "hash.h"		//funciones para la tabla hash
#include "init.h"		//inicia el tablero y lee el archivo ini
#include "attack.h"		//comprueba si el rey est en jaque y una casilla atacada
#include "genmoves.h"	//funciones para generar, hacer y deshacer movimientos
#include "eval.h"		//evaluacin de una posicin
#include "gui_eng.h"	//informacin GUI -> motor
#include "eng_gui.h"	//informacin motor -> GUI
#include "fen.h"		//soporte para posiciones en formato fen
#include "search.h"		//bsqueda del mejor movimiento
#include "ponder.h"		//bsqueda del mejor movimiento durante el ponder
#include "xboard.h"		//soporte para el protocolo xboard

int	main()
{
    char	s[256];

	printf("%s, web: http://danasah.tk \n", nombre);
	printf("%s, Pedro Castro, Spain\n", fecha);
	printf("\n");
	printf("DanaSah only supports the winboard interface.\n");
	printf("Type command quit to exit\n");
	printf("\n");


	leer_inifile();		//leemos el fichero de configuracin de danasah (danasah.ini)
	inicia_hash();		//inicia las tablas hash
	//IniciaTablero();	//inicializaciones para una nueva partida
	motor = VACIO;
	salir = FALSO;

	// TTables
	//TTProbes = 0;
	//TTStores = 0;
	//TTHits = 0;

	//abrir_libro();		//abrimos el libro de aperturas

    for (;;) {
        // encuentra la entrada del usuario
        printf("danasah> ");
        if (scanf("%s", s) == EOF) // cierra el programa
            return (0);
		
		if (!strcmp(s, "quit")) {
            // TTables           
			free_hash();	// al salir del programa liberamos la memoria de tablas hash
			break;
		}
		if (!strcmp(s, "xboard")) {
			xboard();		// mandamos el control a la funcin xboard
			break;
		}
	}
	cerrar_libro();	//cerramos el libro de aperturas si salimos del programa
	return (0);
}
